//
// Share.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct Share: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var seen: Bool?
    public var receiverId: Int?
    public var senderId: Int?
    public var propertyId: Int?
    public var updatedAt: Date?
    public var createdAt: Date?
    public var receiver: User?
    public var sender: User?
    public var property: Property?

    public init(id: Int? = nil, seen: Bool? = nil, receiverId: Int? = nil, senderId: Int? = nil, propertyId: Int? = nil, updatedAt: Date? = nil, createdAt: Date? = nil, receiver: User? = nil, sender: User? = nil, property: Property? = nil) {
        self.id = id
        self.seen = seen
        self.receiverId = receiverId
        self.senderId = senderId
        self.propertyId = propertyId
        self.updatedAt = updatedAt
        self.createdAt = createdAt
        self.receiver = receiver
        self.sender = sender
        self.property = property
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case seen
        case receiverId
        case senderId
        case propertyId
        case updatedAt
        case createdAt
        case receiver = "Receiver"
        case sender = "Sender"
        case property = "Property"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(seen, forKey: .seen)
        try container.encodeIfPresent(receiverId, forKey: .receiverId)
        try container.encodeIfPresent(senderId, forKey: .senderId)
        try container.encodeIfPresent(propertyId, forKey: .propertyId)
        try container.encodeIfPresent(updatedAt, forKey: .updatedAt)
        try container.encodeIfPresent(createdAt, forKey: .createdAt)
        try container.encodeIfPresent(receiver, forKey: .receiver)
        try container.encodeIfPresent(sender, forKey: .sender)
        try container.encodeIfPresent(property, forKey: .property)
    }
}

